#!/usr/local/bin/perl

use Net::SMTP;
use strict;

my(%varHash, $deck, $options);
my(%contact, $key);

%varHash = GetVariables();

# If "email" is set via get or post, run SendMail()
if( defined($varHash{"email"}) )  {
  SendMail($varHash{"email"}, $varHash{"tocall"});
}

# Load the Contact Database
%contact = GetData();

# Set the content-type (begin file with "nph-")
print "Content-type: text/vnd.wap.wml\n\n";

# load the static WML
$deck ='<?xml version="1.0"?>
<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.2//EN"
         "http://www.wapforum.org/DTD/wml_1.2.xml">
<wml>
  <card id="card1">
    <select>
    %s
    </select>
  </card>
  <card id="card2">
    <p>
      $person
    </p>
    <select>
      <option onpick="wtai://$(number)/">Call</option>
      <option onpick="#card3">Email</option>
    </select>
  </card>
  <card id="card3">
    <p>
      Enter phone #
      <input name="tocall" maxlength="20" />
    </p>
    <do type="accept">
      <go href="#card4" method="get">
        <postfield name="email" value="$(email:n)" />
        <postfield name="tocall" value="$(tocall:n)" />
      </go>
    </do>
  </card>
  <card id="card4">
    <p>
      <do type="accept">
        <go href="#card1" />
      </do>
      Email Sent!
    </p>
  </card>
</wml>';

# Create the Dynamic WML
$options = "";
foreach $key (keys %contact) {
  $options .= '<option>' . "\n";
  $options .= '  <onevent type="onpick">' . "\n";
  $options .= '    <go href="#card2">' . "\n";
  $options .= '      <setvar name="person" value="';
  $options .= $contact{$key}[0] . '" />' . "\n";
  $options .= '      <setvar name="number" value="';
  $options .= $contact{$key}[1] . '" />' . "\n";
  $options .= '      <setvar name="email" value="';
  $options .= $contact{$key}[2] . '" />' . "\n";
  $options .= '    </go>' . "\n" . '  </onevent>';
  $options .= $contact{$key}[0] . "\n";
  $options .= '</option>' . "\n";
}
chomp $options;

# Combine Static and Dynamic WML and send to browser
printf($deck, $options);

# Subroutine to load database from file
sub GetData {

  my( $DATA_FILE, %contact, @line);

  # contact Database file
  $DATA_FILE = 'c:\userlist.data';

  open(FILE,$DATA_FILE) || die;

  while (<FILE>) {
    chomp;
    @line = split(/\|/, $_, 3);
    $contact{$line[0]} = [ @line ];
  }
  close(FILE);

  return %contact;
}

# Subroutine to Send Email Message
sub SendMail{

  my ($email, $phone, $smtp);
  $email = shift;
  $phone = shift;

  $smtp = Net::SMTP->new('mail.yourserver.com');
  $smtp->mail('Wireless Phone Redirector');
  $smtp->to($email);
  $smtp->data();
  $smtp->datasend("To: " . $email . "\n");
  $smtp->datasend("Subject: Please Call\n");
  $smtp->datasend("\n");
  $smtp->datasend("Please call " . $phone . "\n");
  $smtp->dataend();
  $smtp->quit;
}

# Subroutine to Parse GET,POST Variables
sub GetVariables {
  my($queryStr, $i, $name, $value, %varHash);

  #Get any GET Data
  $queryStr = $ENV{'QUERY_STRING'};

  # Append any POST data to GET Data
  if ($ENV{'REQUEST_METHOD'} eq "POST") {
    if ($queryStr ne "") {
      $queryStr .= "&";
    }
    for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
      $queryStr .= getc;
    }
  }

  foreach (split(/&/, $queryStr)) {

    # URL Decode if necessary
    s/\+/ /g;
    s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("c",hex($1))/ge;

    # Split into variable and value.
    ($name, $value) = split(/=/, $_, 2);

    $varHash{$name} = $value;

    }

  # Return Hash of Variables
  return %varHash;
}
