import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.javadesktop.javadeck.*;
import com.javadesktop.javadeck.elements.*;
import com.javadesktop.javadeck.constants.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class WapServlet extends HttpServlet {

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws IOException, ServletException {

  if (request.getParameter("email") != null) {
    String email = request.getParameter("email");
    String pnum = request.getParameter("tocall");
    SendMail(email, pnum);
  } 

  response.setContentType("text/vnd.wap.wml");
  PrintWriter out = response.getWriter();

  //First Card
  Card card = new Card("card1", "Choose Contact");
    Select select = new Select();
    Hashtable contacts = new Hashtable();
    Enumeration List;
    contacts = GetData();
    List = contacts.keys();
    while (List.hasMoreElements()) {
      String listItem = (String)List.nextElement();
      String[] data = (String[])(contacts.get(listItem));
      select.addElement(createOption(data));
    }
  card.addElement(select);

  //Second Card
  Card card2 = new Card("card2", "Choose Method")
    .addElement(new P(Alignment.LEFT, Mode.WRAP)
      .addElement("$person"))
    .addElement(new Select()
      .addElement(new Option()
        .setOnPick("wtai://$(number)/")
        .addElement("Call"))
      .addElement(new Option()
        .setOnPick("#card3")
        .addElement("Email")));
      
  //Third Card
  Card card3 = new Card("card3", "Phone Input")
    .addElement(new P(Alignment.LEFT, Mode.WRAP)
      .addElement("Enter phone #")
      .addElement(new Input("tocall")
        .setMaxLength(20))
    .addElement(new Do(DoType.ACCEPT)
      .addElement(new Go("#card4", Method.GET)
        .addElement(new Postfield("email", "$(email:n)"))
        .addElement(new Postfield("tocall", 
          "$(tocall:n)")))));      

  //Fourth Card
  Card card4 = new Card("card4", "Email Notice")
    .addElement(new P()
      .addElement(new Do(DoType.ACCEPT)
        .addElement(new Go("#card1")))
      .addElement("Email Sent!"));
  
  //Compose Deck and Send
  WML wml = new WML()
    .addElement(card)
    .addElement(card2)
    .addElement(card3)
    .addElement(card4);
  Deck doc = new Deck(wml);
  out.println(DeckRender.parse(doc.toString()));
  }

  private static Option createOption(String[] data) {

  Option option = new Option()
    .addElement(new Onevent(EventType.ONPICK)
      .addElement(new Go("#card2")
        .addElement(new Setvar("person", data[0]))
        .addElement(new Setvar("number", data[1]))
        .addElement(new Setvar("email", data[2]))))
    .addElement(data[0]);

  return option;
  }

  private static Hashtable GetData() {
  
    String fileName = "c:\\userlist.data";
    String line = null;
    Hashtable hash = new Hashtable();
  
    try {
      FileReader fileReader = new FileReader(fileName);
      BufferedReader bufferedReader 
        = new BufferedReader(fileReader);
  
      while ((line = bufferedReader.readLine()) != null) {
        StringTokenizer st = new StringTokenizer(line, "|");
        String[] data = new String[3];
        data[0] = st.nextToken();
        data[1] = st.nextToken();
        data[2] = st.nextToken();
        hash.put(data[0], data);
      }
      fileReader.close();
    } catch (FileNotFoundException ignored) {}
      catch (IOException ignored) {}
    
    return hash;
  }
  
  private static void SendMail(String emailAddress, String pnum) {
  
    Properties props = System.getProperties();
    props.put("mail.smtp.host", "mail.yourserver.com");
    Session emailsession = 
         Session.getDefaultInstance(props, null);
  
    try {
      Message email = new MimeMessage(emailsession);
      email.setFrom(new InternetAddress("WAP Redirector"));
      InternetAddress[] address 
        = {new InternetAddress(emailAddress)};
      email.setRecipients(Message.RecipientType.TO,address);
      email.setSubject("Please Call");
      email.setSentDate(new Date());
      email.setHeader("X-Mailer","Wireless Redirector");
      email.setText("Please call " + pnum);
      Transport.send(email);
    } catch (MessagingException ignored) {}
  }
}
