import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.javadesktop.javadeck.*;
import com.javadesktop.javadeck.elements.*;
import com.javadesktop.javadeck.constants.*;
import com.javadesktop.javadeck.digest.*;

public class MultiServlet extends HttpServlet {

 protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
                     throws ServletException, 
                              java.io.IOException {
     
	 Digest mpm = new Digest();
	 String boundry = mpm.getBoundry();
     response.setContentType("multipart/mixed;boundary=\"" 
	   + boundry +"\"");
     ServletOutputStream out = response.getOutputStream();

	 WbmpContent image1 = new WbmpContent("?image1")
	   .setFile("c:\\images\\n1.wbmp");

	 WbmpContent image2 = new WbmpContent("?image2")
	   .setFile("c:\\images\\n2.wbmp");

	 WbmpContent image3 = new WbmpContent("?image3")
	   .setFile("c:\\images\\n3.wbmp");

	 WbmpContent image4 = new WbmpContent("?image4")
	   .setFile("c:\\images\\n4.wbmp");

	 WbmpContent image5 = new WbmpContent("?image5")
	   .setFile("c:\\images\\n5.wbmp");

     // Add WML Cards to Digest
	 WML w = new WML()
	   .addElement(createCard("image1", "image2", "15"))
	   .addElement(createCard("image2", "image3", "3"))
	   .addElement(createCard("image3", "image4", "3"))
	   .addElement(createCard("image4", "image5", "3"))
	   .addElement(createCard("image5", "image1", "3"));
	 Deck doc = new Deck(w);
	 mpm.addContent(new WmlContent("?wc1", (doc)));

     // Add Binary Image Files to Digest
	 mpm.addContent(image1);
	 mpm.addContent(image2);
	 mpm.addContent(image3);
	 mpm.addContent(image4);
	 mpm.addContent(image5);
	 mpm.sendDigest(out);
   }

   private static Card createCard(String imageName, 
                      String nextImage, String timeOut) {
   
       Card card = new Card(imageName, "");
	   card.setCardOnTimer("#" + nextImage);
	   
	   Timer t = new Timer(timeOut);
	   card.addElement(t);

	   P para = new P(Alignment.CENTER, Mode.WRAP);
	   BR br = new BR();
	   Img img = new Img("?" + imageName, "");
	   para.addElement(br);
	   para.addElement(img);
	   card.addElement(para);
       return(card);
   }
}
